package com.chinaitop.depot.customer.service;

import java.util.List;
import java.util.Map;

import com.chinaitop.depot.customer.model.BusinessCustomer;
import com.chinaitop.depot.customer.model.BusinessCustomerExample;



public interface BusinessCustomerService {
	
	List<BusinessCustomer> queryByExample(BusinessCustomerExample example);
	
	BusinessCustomer findById(Integer id);
	
	void add(BusinessCustomer customer, Integer orgId);
	
	void update(BusinessCustomer customer);
	
	void remove(Integer id);

    /**
     * 加入黑名单.
     * @param id
     * @return
     */
    Map<String, Object> putInBlackList(Integer id);

    /**
     * 移出黑名单.
     * @param id
     * @return
     */
    Map<String, Object> removeBlackList(Integer id);

    /**
     * 查询列表.
     * @param pageNum
     * @param pageSize
     * @param customer
     * @param userInfo
     * @return
     */
    List<BusinessCustomer> list(Integer pageNum, Integer pageSize,
            BusinessCustomer customer, Integer orgId);

}
