package com.chinaitop.depot.customer.service.impl;

import java.util.List;

import javax.annotation.Resource;

import org.springframework.stereotype.Service;

import com.chinaitop.depot.customer.mapper.BusinessCustomerBadrecordMapper;
import com.chinaitop.depot.customer.model.BusinessCustomer;
import com.chinaitop.depot.customer.model.BusinessCustomerBadrecord;
import com.chinaitop.depot.customer.model.BusinessCustomerBadrecordExample;
import com.chinaitop.depot.customer.service.BusinessCustomerBadrecordService;
import com.chinaitop.depot.customer.service.BusinessCustomerService;


@Service
public class BusinessCustomerBadrecordServiceImpl implements BusinessCustomerBadrecordService {
	
	@Resource
	private BusinessCustomerBadrecordMapper customerBadrecordMapper;
	@Resource
	private BusinessCustomerService customerService;

	public List<BusinessCustomerBadrecord> queryByExample(BusinessCustomerBadrecordExample example) {
		return customerBadrecordMapper.selectByExample(example);
	}

	
	public BusinessCustomerBadrecord findById(Integer id) {
		return customerBadrecordMapper.selectByPrimaryKey(id);
	}

	
	public void add(BusinessCustomerBadrecord customerBadrecord) {
		customerBadrecordMapper.insert(customerBadrecord);
		
		Integer customerId = customerBadrecord.getCustomerId();
		BusinessCustomer customer = customerService.findById(customerId);
		// 判断客户的是否有不良记录.
		if (!"1".equals(customer.getIsHaveBadrecord())) {
		    // 如果没有，就记录为有.
		    customer.setIsHaveBadrecord(1);
		    customerService.update(customer);
		}
	}

	
	public void update(BusinessCustomerBadrecord customerBadrecord) {
		customerBadrecordMapper.updateByPrimaryKey(customerBadrecord);
	}

	
	public void remove(Integer id) {
	    BusinessCustomerBadrecord customerBadrecord = customerBadrecordMapper.selectByPrimaryKey(id);
	    Integer customerId = customerBadrecord.getCustomerId();
        BusinessCustomer customer = customerService.findById(customerId);
        
		customerBadrecordMapper.deleteByPrimaryKey(id);
		
		BusinessCustomerBadrecordExample example = new BusinessCustomerBadrecordExample();
		example.createCriteria().andCustomerIdEqualTo(customerId);
		int count = customerBadrecordMapper.countByExample(example);
		if (count == 0) {
		    // 修改客户的不良记录为无.
		    customer.setIsHaveBadrecord(0);
		    customerService.update(customer);
		}
	}


    public List<BusinessCustomerBadrecord> selectBadreocrdJoinBusinessCustomer(BusinessCustomerBadrecord customerBadrecord) {
        return customerBadrecordMapper.selectBadreocrdJoinBusinessCustomer(customerBadrecord);
    }


	@Override
	public List<BusinessCustomerBadrecord> selectBadreocrdJoinBusinessCustomerEdit(
			BusinessCustomerBadrecord customerBadrecord) {
		// TODO Auto-generated method stub
		return customerBadrecordMapper.selectBadreocrdJoinBusinessCustomerEdit(customerBadrecord);
	}

}
